> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/web/annotation/annotation-types/lineannotation.md).

# Line Annotations

Create precise line annotations with start and end points. Customize stroke color, border style, and line endings. Explore XFDFElement properties for page number, start, end, stroke color, and more. T

Line annotations are lines with two specific points: start and end. Arrow annotations and measurement lines are all actually just line annotations. They are created using different line endings and captions available on the line annotation already.

Line annotations primarily use a stroke color but could have a fill color that only affects closed line ending styles. The stroke or border style can also be changed between a solid or dashed style. Lines can also have [line ending styles](https://sdk.apryse.com/api/web/Core.Annotations.html#.LineEndType) set on either end of the line. The line endings are also affected by the currently styles on the line.

![](https://3532544125-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FX9YnTSKIHvV7m0A36LbO%2Fuploads%2Fgit-blob-321aa95750058bdf92e66d6a24937a3e667eed39%2F2b5eed26ce55e8d7ead709e0536d885da7b40b95-208x129.png?alt=media)

## Instantiation

{% tabs %}
{% tab title="JavaScript (SDK v8.0+)" %}
{% code lineNumbers="true" %}

```js
WebViewer(...)
  .then(instance => {
    const { documentViewer, annotationManager, Annotations } = instance.Core;

    documentViewer.addEventListener('annotationsLoaded', () => {
      const annot = new Annotations.LineAnnotation({
        PageNumber: 1,
        Start: new Annotations.Point(50, 50),
        End: new Annotations.Point(100, 100),
        StrokeColor: new Annotations.Color(0, 255, 0, 1),
      });

      annotationManager.addAnnotation(annot);
      annotationManager.redrawAnnotation(annot);
    });
  });
```

{% endcode %}

[AnnotationManager#annotationsLoaded](https://sdk.apryse.com/api/web/Core.AnnotationManager.html#event:annotationsLoaded) [LineAnnotation](https://sdk.apryse.com/api/web/Core.Annotations.LineAnnotation.html) [Point](https://sdk.apryse.com/api/web/Core.Math.Point.html) [Color](https://sdk.apryse.com/api/web/Core.Annotations.Color.html) [AnnotationManager.addAnnotation](https://sdk.apryse.com/api/web/Core.AnnotationManager.html#addAnnotation) [AnnotationManager.redrawAnnotation](https://sdk.apryse.com/api/web/Core.AnnotationManager.html#redrawAnnotation)
{% endtab %}

{% tab title="JavaScript (SDK v6.0+)" %}
{% code lineNumbers="true" %}

```js
WebViewer(...)
  .then(instance => {
    const { docViewer, annotManager, Annotations } = instance;

    docViewer.on('annotationsLoaded', () => {
      const annot = new Annotations.LineAnnotation();
      annot.PageNumber = 1;
      Start: new Annotations.Point(50, 50);
      End: new Annotations.Point(100, 100);
      StrokeColor: new Annotations.Color(0, 255, 0, 1);

      annotManager.addAnnotation(annot);
      annotManager.redrawAnnotation(annot);
    });
  });
```

{% endcode %}

[AnnotationManager#annotationsLoaded](https://sdk.apryse.com/api/web/Core.AnnotationManager.html#event:annotationsLoaded) [LineAnnotation](https://sdk.apryse.com/api/web/Core.Annotations.LineAnnotation.html) [Point](https://sdk.apryse.com/api/web/Core.Math.Point.html) [Color](https://sdk.apryse.com/api/web/Core.Annotations.Color.html) [AnnotationManager.addAnnotation](https://sdk.apryse.com/api/web/Core.AnnotationManager.html#addAnnotation) [AnnotationManager.redrawAnnotation](https://sdk.apryse.com/api/web/Core.AnnotationManager.html#redrawAnnotation)
{% endtab %}
{% endtabs %}

## XFDF

Element name: `line`

{% tabs %}
{% tab title="Shell" %}
{% code lineNumbers="true" %}

```sh
<line page="0" rect="252.430,620.280,347.070,645.440" color="#E44234" flags="print" name="3c0708a6-b0ac-c154-3637-3056384811ae" title="Guest" subject="Line" date="D:20220620170239-07'00'" creationdate="D:20220620170238-07'00'" start="253.43,644.44" end="346.07,621.28"/>
```

{% endcode %}
{% endtab %}
{% endtabs %}

## Required properties

### PageNumber

Gets or sets the page number of a document that the annotation appears on.

### Start

Gets or sets the start point of the line.

### End

Gets or sets the end point of the line.

## Notable properties

For the full list of properties, please visit the annotation's [API docs](https://sdk.apryse.com/api/web/Core.Annotations.LineAnnotation.html).

### StrokeColor

Gets or sets the color of the annotation's stroke.

### Style

Gets or sets the border style of an annotation. Possible styles include:

* solid
* dash

### Dashes

Gets or sets the border dash style of an annotation. This expects a string representing the length of dashes and spacing inbetween, delimited by commas (ex. `3, 3`). You can specify any amount of lengths but, an odd number of values will be made even by cloning it as a second set. To understand further, you can read more about the [`setLineDash`](https://developer.mozilla.org/en-US/docs/Web/API/CanvasRenderingContext2D/setLineDash/) API.

### StrokeThickness

Gets or sets the width of the annotation's stroke outline.

### caption

Gets or sets the caption on the line

### caption-style

Gets or sets the caption position style. This can either be `Top` or `Inline`

### caption-offset-h

Gets or sets the horizontal offset of the caption from the line

### caption-offset-v

Gets or sets the vertical offset of the caption from the line

### leaderLength

Gets or sets the length of the leader lines. Values above/below 0 will render the lines

### Author

The author of the annotation.

### Color

Gets or sets the annotation's stroke color.

### Hidden

Gets or sets whether the annotation is hidden.

### Invisible

Gets or sets whether the annotation is invisible, only if it is an unknown annotation type. Generally for hiding annotations you should use "Hidden".

### IsClickableOutsideRect

Gets or sets whether any parts of the annotation drawn outside of the rect are clickable.

### Listable

Gets or sets whether the annotation should be listed in annotation lists. If set to false, the annotation will also become unselectable.

### Locked

Gets or sets whether the annotation is locked or not. If it's locked it can't be edited or deleted, but the note can be edited.

### LockedContents

Gets or sets whether the annotation contents are locked or not. If the contents are locked then note can't be edited but the annotation can be edited or deleted.

### NoDelete

Gets or sets if this annotation can be deleted.

### NoMove

Gets or sets whether or not the annotation can be moved.

### NoResize

Gets or sets if this annotation can be resized by the user.

### NoRotate

Gets or sets if this annotation can be rotated.

### NoView

Gets or sets whether the annotation is visible on the screen. Differs from Hidden in that it can still be printed if the print flag is set.

### NoZoom

Gets or sets if this annotation scales with the page.

### Printable

Gets or sets whether the annotation should be displayed when printing the page.

### ReadOnly

Gets or sets whether the annotation is readonly or not. If it's readonly both the annotation itself and its note can't be edited or deleted.

### ToggleNoView

Gets or sets whether the ToggleNoView flag is set on the annotation.

## Useful methods

### getLineLength

You may be interested in the length of a line for positioning or precision. Line annotations provide a [`getLineLength`](https://sdk.apryse.com/api/web/Core.Annotations.LineAnnotation.html#getLineLength) API to return that length.

### setLineLength

To adjust a line, you could change the `Start` and `End` points but if you need a specific length, you should use [`setLineLength`](https://sdk.apryse.com/api/web/Core.Annotations.LineAnnotation.html#setLineLength) to adjust the length. Changing the length will only move the `End` point.

{% tabs %}
{% tab title="JavaScript (SDK v8.0+)" %}
{% code lineNumbers="true" %}

```js
WebViewer(...)
  .then(instance => {
    const { annotationManager, Annotations } = instance.Core;

    annotationManager.addEventListener('annotationChanged', (annotations, action) => {
      if (action === 'add') {
        annotations.forEach(annot => {
          if (annot instanceof Annotations.LineAnnotation) {
            if (annot.X < 800 && annot.Y < 540) {
              annot.setLineLength(annot.getLineLength() / 3);
            }
          }
        });
      }
    });
  });
```

{% endcode %}

[AnnotationManager#annotationChanged](https://sdk.apryse.com/api/web/Core.AnnotationManager.html#event:annotationChanged) [LineAnnotation.getLineLength](https://sdk.apryse.com/api/web/Core.Annotations.LineAnnotation.html#getLineLength) [LineAnnotation.setLineLength](https://sdk.apryse.com/api/web/Core.Annotations.LineAnnotation.html#setLineLength)
{% endtab %}

{% tab title="JavaScript (SDK v6.0+)" %}
{% code lineNumbers="true" %}

```js
WebViewer(...)
  .then(instance => {
    const { annotManager, Annotations } = instance.Core;

    annotManager.on('annotationChanged', (annotations, action) => {
      if (action === 'add') {
        annotations.forEach(annot => {
          if (annot instanceof Annotations.LineAnnotation) {
            if (annot.X < 800 && annot.Y < 540) {
              annot.setLineLength(annot.getLineLength() / 3);
            }
          }
        });
      }
    });
  });
```

{% endcode %}

[AnnotationManager#annotationChanged](https://sdk.apryse.com/api/web/Core.AnnotationManager.html#event:annotationChanged) [LineAnnotation.getLineLength](https://sdk.apryse.com/api/web/Core.Annotations.LineAnnotation.html#getLineLength) [LineAnnotation.setLineLength](https://sdk.apryse.com/api/web/Core.Annotations.LineAnnotation.html#setLineLength)
{% endtab %}
{% endtabs %}

### getStartStyle

If you need to know the line ending style of the starting point, the [`getStartStyle`](https://sdk.apryse.com/api/web/Core.Annotations.LineAnnotation.html#getStartStyle) API will return the string value representing the style. Check out [`LineEndType`](https://sdk.apryse.com/api/web/Core.Annotations.html#.LineEndType) to see the possible values.

### setStartStyle

To set the style of the starting point of a line, the ['setStartStyle'](https://sdk.apryse.com/api/web/Core.Annotations.LineAnnotation.html#setStartStyle) API will change it to the specified style. It is recommended to use the [`LineEndType`](https://sdk.apryse.com/api/web/Core.Annotations.html#.LineEndType) constant to get the value.

{% tabs %}
{% tab title="JavaScript (SDK v8.0+)" %}
{% code lineNumbers="true" %}

```js
WebViewer(...)
  .then(instance => {
    const { annotationManager, Annotations } = instance.Core;

    annotationManager.addEventListener('annotationChanged', (annotations, action) => {
      if (action === 'add') {
        annotations.forEach(annot => {
          if (annot instanceof Annotations.LineAnnotation) {
            annot.setStartStyle(Annotations.LineEndType.OPEN_ARROW);
          }
        });
      }
    });
  });
```

{% endcode %}

[LineAnnotation.setStartStyle](https://sdk.apryse.com/api/web/Core.Annotations.LineAnnotation.html#setStartStyle) [LineEndType](https://sdk.apryse.com/api/web/Core.Annotations.html#.LineEndType)
{% endtab %}

{% tab title="JavaScript (SDK v6.0+)" %}
{% code lineNumbers="true" %}

```js
WebViewer(...)
  .then(instance => {
    const { annotManager, Annotations } = instance.Core;

    annotManager.on('annotationChanged', (annotations, action) => {
      if (action === 'add') {
        annotations.forEach(annot => {
          if (annot instanceof Annotations.LineAnnotation) {
            annot.setStartStyle(Annotations.LineEndType.OPEN_ARROW);
          }
        });
      }
    });
  });
```

{% endcode %}

[LineAnnotation.setStartStyle](https://sdk.apryse.com/api/web/Core.Annotations.LineAnnotation.html#setStartStyle) [LineEndType](https://sdk.apryse.com/api/web/Core.Annotations.html#.LineEndType)
{% endtab %}
{% endtabs %}

### getEndStyle

If you need to know the line ending style of the ending point, the [`getEndStyle`](https://sdk.apryse.com/api/web/Core.Annotations.LineAnnotation.html#getEndStyle) API will return the string value representing the style. Check out [`LineEndType`](https://sdk.apryse.com/api/web/Core.Annotations.html#.LineEndType) to see the possible values.

### setEndStyle

To set the style of the ending point of a line, the ['setEndStyle'](https://sdk.apryse.com/api/web/Core.Annotations.LineAnnotation.html#setEndStyle) API will change it to the specified style. It is recommended to use the [`LineEndType`](https://sdk.apryse.com/api/web/Core.Annotations.html#.LineEndType) constant to get the value.

{% tabs %}
{% tab title="JavaScript (SDK v8.0+)" %}
{% code lineNumbers="true" %}

```js
WebViewer(...)
  .then(instance => {
    const { annotationManager, Annotations } = instance.Core;

    annotationManager.addEventListener('annotationChanged', (annotations, action) => {
      if (action === 'add') {
        annotations.forEach(annot => {
          if (annot instanceof Annotations.LineAnnotation) {
            annot.setEndStyle(Annotations.LineEndType.OPEN_ARROW);
          }
        });
      }
    });
  });
```

{% endcode %}

[LineAnnotation.setEndStyle](https://sdk.apryse.com/api/web/Core.Annotations.LineAnnotation.html#setEndStyle)
{% endtab %}

{% tab title="JavaScript (SDK v6.0+)" %}
{% code lineNumbers="true" %}

```js
WebViewer(...)
  .then(instance => {
    const { annotManager, Annotations } = instance.Core;

    annotManager.on('annotationChanged', (annotations, action) => {
      if (action === 'add') {
        annotations.forEach(annot => {
          if (annot instanceof Annotations.LineAnnotation) {
            annot.setEndStyle(Annotations.LineEndType.OPEN_ARROW);
          }
        });
      }
    });
  });
```

{% endcode %}

[LineAnnotation.setEndStyle](https://sdk.apryse.com/api/web/Core.Annotations.LineAnnotation.html#setEndStyle)
{% endtab %}
{% endtabs %}

## Other notes

### LineEndType

The line annotation ending styles can be set with the values provided by the [`LineEndType`](https://sdk.apryse.com/api/web/Core.Annotations.html#.LineEndType) constant or strings. The string values of the line ending styles supported by the specification are:

* None - No line ending. This is default.
* OpenArrow - An open-ended arrow.
* ROpenArrow - A reversed, open-ended arrow.
* ClosedArrow - A closed arrow. This is affected by `FillColor`.
* RClosedArrow - A reversed, closed arrow. This is affected by `FillColor`.
* Butt - A perpendicular straight line.
* Square - A square. This is affected by `FillColor`.
* Diamond - A diamond or square rotated 90 degrees. This is affected by `FillColor`.
* Circle - A circle. This is affected by `FillColor`.
* Slash - A line going from right to left.

`StrokeThickness` also affects the size of the line endings.

![](https://3532544125-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FX9YnTSKIHvV7m0A36LbO%2Fuploads%2Fgit-blob-ba2284e1e1c71dc9451c8aaa2fdaaa0d41a96f9c%2F7c3da2634f8be134e5bd75917707facfa61afa37-370x501.png?alt=media)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/web/annotation/annotation-types/lineannotation.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
